
{$ifndef BG_H}
{$define BG_H}


// REG_DISPCNT
function DISP_BGMODE(x: u32): u32;
begin
  DISP_BGMODE := x;
end;

function DISP_SELECTBUFFER(x: u32): u32;
begin
  DISP_SELECTBUFFER := (x shl 4);
end;

const 
  DISP_HBLANK_PROCESS_ON = (0 shl 5);
  DISP_HBLANK_PROCESS_OFF = (1 shl 5);

  DISP_SPRITE_TYPE_1D = (1 shl 6);
  DISP_SPRITE_TYPE_2D = (0 shl 6);

  DISP_FORCE_BLANK  = (1 shl 7);

  DISP_BG0  = (1 shl 8);
  DISP_BG1  = (1 shl 9);
  DISP_BG2  = (1 shl 10);
  DISP_BG3  = (1 shl 11);
  DISP_OBJ  = (1 shl 12);

  DISP_WND0 = (1 shl 13);
  DISP_WND1 = (1 shl 14);
  DISP_OBJWND = (1 shl 15);


// REG_DISPSTAT

  DSTAT_BIT_VBLANK  = (1);
  DSTAT_BIT_HBLANK  = (1 shl 1);
  DSTAT_BIT_VCOUNT  = (1 shl 2);

  DSTAT_USE_VBLANK  = (1 shl 3);
  DSTAT_USE_HBLANK  = (1 shl 4);
  DSTAT_USE_VCOUNT  = (1 shl 5);

function DSTAT_VCOUNT_LINE(x: u32): u32;
begin
  DSTAT_VCOUNT_LINE := ((x) shl 8);
end;


// REG_VCOUNT
const
  BG_SIZEA_256_256  = 0;
  BG_SIZEA_512_256  = (1 shl 14);
  BG_SIZEA_256_512  = (2 shl 14);
  BG_SIZEA_512_512  = (3 shl 14);

  BG_SIZEB_128_128  = 0;
  BG_SIZEB_256_256  = (1 shl 14);
  BG_SIZEB_512_512  = (2 shl 14);
  BG_SIZEB_1024_1024= (2 shl 14);

  BG_OVERLAP  = (1 shl 13);

function BG_MAPBASE(x: u32): u32;
begin
  BG_MAPBASE := ((x) shl 8);
end;

const
  BG_COLOR_16   = 0;
  BG_COLOR_256  = (1 shl 7);

  BG_MOZAIC_ON  = (1 shl 6);

function BG_CHARBASE(x: u32): u32;
begin
  BG_CHARBASE:=((x) shl 2);
end;

function BG_PRIORITY(x: u32): u32;
begin
  BG_PRIORITY:=x;
end;


function BG_MAP_PAL(x: u32): u32;
begin
  BG_MAP_PAL:=((x) shl 12);
end;

const
  BG_MAP_YFLIP  = (1 shl 11);
  BG_MAP_XFLIP  = (1 shl 10);

function BG_MAP_TILE(x: u16): u16;
begin
  BG_MAP_TILE:=(x)
end;

function MEM_BG_CHAR(x: u16): pointer;
begin
  MEM_BG_CHAR := pointer($6000000 + (x)*$4000);
end;

function MEM_BG_MAP(x: u16): pointer;
begin
  MEM_BG_MAP :=  pointer($6000000 + (x)* $800);
end;

const
  MEM_BG_PAL  : ^u16 = pointer($5000000);



{$endif}

