

{$ifndef IRQ_H}
{$define IRQ_H}


// REG_INTERUPT

procedure SetIRQ(x: u32);
begin
  REG_INTERUPT^ := x;
end;

// REG_IME
const
  IRQ_MASTER_ON  = 1;
  IRQ_MASTER_OFF = 0;


// REG_IE, REG_IF

const 
  IRQ_BIT_VBLANK  = (1 shl 0);
  IRQ_BIT_HBLANK  = (1 shl 1);
  IRQ_BIT_VCOUNT  = (1 shl 2);
  IRQ_BIT_TIMER0  = (1 shl 3);
  IRQ_BIT_TIMER1  = (1 shl 4);
  IRQ_BIT_TIMER2  = (1 shl 5);
  IRQ_BIT_TIMER3  = (1 shl 6);
  IRQ_BIT_SERIAL  = (1 shl 7);
  IRQ_BIT_DMA0    = (1 shl 8);
  IRQ_BIT_DMA1    = (1 shl 9);
  IRQ_BIT_DMA2    = (1 shl 10);
  IRQ_BIT_DMA3    = (1 shl 11);
  IRQ_BIT_KEYS    = (1 shl 12);
  IRQ_BIT_CART    = (1 shl 13);


{$endif}


