// Conversion by Legolas (http://itaprogaming.free.fr) 

//
// Registers
//


{$ifndef GBA_REGS_H}
{$define GBA_REGS_H}

{$include gba_types.inc}



const
  OAMMem          : ^u16 = pointer($7000000); // Sprites(128), coordinates, size..(total 1Kb)
  VideoBuffer     : ^u16 = pointer($6000000); // Front Display Memory (the screen in mode 3-5)
  SecondBuffer    : ^u16 = pointer($600A000); // Front Display Memory (the screen in mode 3-5)
  
  OAMData         : ^u16 = pointer($6010000); // Sprite data (bitmapped)
  OAMdataTile     : ^u16 = pointer($6010000);
  OAMdataBmp      : ^u16 = pointer($6014000);

  BGPal           : ^u16 = pointer($5000000); // Background Palette(256/16 colors)
  OBJPal          : ^u16 = pointer($5000200); // Sprite Palette(256/16 colors)

  REG_INTERUPT    : ^u32 = pointer($3007FFC);
  REG_DISPCNT     : ^u32 = pointer($4000000);  // Display control mode
  REG_DISPCNT_L   : ^u16 = pointer($4000000);
  REG_DISPCNT_H   : ^u16 = pointer($4000002);
  REG_DISPSTAT    : ^u16 = pointer($4000004);
{$OPTIMIZATION OFF}
  REG_VCOUNT      : ^u16 = pointer($4000006);  // Vertical control sync
{$OPTIMIZATION ON}
  REG_BG0CNT      : ^u16 = pointer($4000008);
  REG_BG1CNT      : ^u16 = pointer($400000A);
  REG_BG2CNT      : ^u16 = pointer($400000C);
  REG_BG3CNT      : ^u16 = pointer($400000E);
  REG_BG0HOFS     : ^u16 = pointer($4000010);
  REG_BG0VOFS     : ^u16 = pointer($4000012);
  REG_BG1HOFS     : ^u16 = pointer($4000014);
  REG_BG1VOFS     : ^u16 = pointer($4000016);
  REG_BG2HOFS     : ^u16 = pointer($4000018);
  REG_BG2VOFS     : ^u16 = pointer($400001A);
  REG_BG3HOFS     : ^u16 = pointer($400001C);
  REG_BG3VOFS     : ^u16 = pointer($400001E);
  REG_BG2PA       : ^u16 = pointer($4000020);
  REG_BG2PB       : ^u16 = pointer($4000022);
  REG_BG2PC       : ^u16 = pointer($4000024);
  REG_BG2PD       : ^u16 = pointer($4000026);
  REG_BG2X        : ^u32 = pointer($4000028);
  REG_BG2X_L      : ^u16 = pointer($4000028);
  REG_BG2X_H      : ^u16 = pointer($400002A);
  REG_BG2Y        : ^u32 = pointer($400002C);
  REG_BG2Y_L      : ^u16 = pointer($400002C);
  REG_BG2Y_H      : ^u16 = pointer($400002E);
  REG_BG3PA       : ^u16 = pointer($4000030);
  REG_BG3PB       : ^u16 = pointer($4000032);
  REG_BG3PC       : ^u16 = pointer($4000034);
  REG_BG3PD       : ^u16 = pointer($4000036);
  REG_BG3X        : ^u32 = pointer($4000038);
  REG_BG3X_L      : ^u16 = pointer($4000038);
  REG_BG3X_H      : ^u16 = pointer($400003A);
  REG_BG3Y        : ^u32 = pointer($400003C);
  REG_BG3Y_L      : ^u16 = pointer($400003C);
  REG_BG3Y_H      : ^u16 = pointer($400003E);
  REG_WIN0H       : ^u16 = pointer($4000040);
  REG_WIN1H       : ^u16 = pointer($4000042);
  REG_WIN0V       : ^u16 = pointer($4000044);
  REG_WIN1V       : ^u16 = pointer($4000046);
  REG_WININ       : ^u16 = pointer($4000048);
  REG_WINOUT      : ^u16 = pointer($400004A);
  REG_MOSAIC      : ^u32 = pointer($400004C);
  REG_MOSAIC_L    : ^u32 = pointer($400004C);
  REG_MOSAIC_H    : ^u32 = pointer($400004E);
  REG_BLDMOD      : ^u16 = pointer($4000050);
  REG_COLEV       : ^u16 = pointer($4000052);
  REG_COLEY       : ^u16 = pointer($4000054);
{$OPTIMIZATION OFF}
  REG_SG10        : ^u32 = pointer($4000060);
  REG_SG10_L      : ^u16 = pointer($4000060);
  REG_SG10_H      : ^u16 = pointer($4000062);
  REG_SG11        : ^u16 = pointer($4000064);
  REG_SG20        : ^u16 = pointer($4000068);
  REG_SG21        : ^u16 = pointer($400006C);
  REG_SG30        : ^u32 = pointer($4000070);
  REG_SG30_L      : ^u16 = pointer($4000070);
  REG_SG30_H      : ^u16 = pointer($4000072);
  REG_SG31        : ^u16 = pointer($4000074);
  REG_SG40        : ^u16 = pointer($4000078);
  REG_SG41        : ^u16 = pointer($400007C);
  REG_SGCNT0      : ^u32 = pointer($4000080);
  REG_SGCNT0_L    : ^u16 = pointer($4000080);
  REG_SGCNT0_H    : ^u16 = pointer($4000082);
  REG_SGCNT1      : ^u16 = pointer($4000084);
  REG_SGBIAS      : ^u16 = pointer($4000088);
  REG_SGWR0       : ^u32 = pointer($4000090);
  REG_SGWR0_L     : ^u16 = pointer($4000090);
  REG_SGWR0_H     : ^u16 = pointer($4000092);
  REG_SGWR1       : ^u32 = pointer($4000094);
  REG_SGWR1_L     : ^u16 = pointer($4000094);
  REG_SGWR1_H     : ^u16 = pointer($4000096);
{$OPTIMIZATION ON}
  REG_SGWR2       : ^u32 = pointer($4000098);
{$OPTIMIZATION OFF}
  REG_SGWR2_L     : ^u16 = pointer($4000098);
  REG_SGWR2_H     : ^u16 = pointer($400009A);
  REG_SGWR3       : ^u32 = pointer($400009C);
  REG_SGWR3_L     : ^u16 = pointer($400009C);
  REG_SGWR3_H     : ^u16 = pointer($400009E);
  REG_SGFIF0A     : ^u32 = pointer($40000A0);
  REG_SGFIFOA_L   : ^u16 = pointer($40000A0);
  REG_SGFIFOA_H   : ^u16 = pointer($40000A2);
  REG_SGFIFOB     : ^u32 = pointer($40000A4);
  REG_SGFIFOB_L   : ^u16 = pointer($40000A4);
  REG_SGFIFOB_H   : ^u16 = pointer($40000A6);
{$OPTIMIZATION ON}

  REG_DM0SAD      : ^u32 = pointer($40000B0);
  REG_DM0SAD_L    : ^u16 = pointer($40000B0);
  REG_DM0SAD_H    : ^u16 = pointer($40000B2);
  REG_DM0DAD      : ^u32 = pointer($40000B4);
  REG_DM0DAD_L    : ^u16 = pointer($40000B4);
  REG_DM0DAD_H    : ^u16 = pointer($40000B6);
  REG_DM0CNT      : ^u32 = pointer($40000B8);
  REG_DM0CNT_L    : ^u16 = pointer($40000B8);
  REG_DM0CNT_H    : ^u16 = pointer($40000BA);
  REG_DM1SAD      : ^u32 = pointer($40000BC);
  REG_DM1SAD_L    : ^u16 = pointer($40000BC);
  REG_DM1SAD_H    : ^u16 = pointer($40000BE);
  REG_DM1DAD      : ^u32 = pointer($40000C0);
  REG_DM1DAD_L    : ^u16 = pointer($40000C0);
  REG_DM1DAD_H    : ^u16 = pointer($40000C2);
  REG_DM1CNT      : ^u32 = pointer($40000C4);
  REG_DM1CNT_L    : ^u16 = pointer($40000C4);
  REG_DM1CNT_H    : ^u16 = pointer($40000C6);
  REG_DM2SAD      : ^u32 = pointer($40000C8);
  REG_DM2SAD_L    : ^u16 = pointer($40000C8);
  REG_DM2SAD_H    : ^u16 = pointer($40000CA);
  REG_DM2DAD      : ^u32 = pointer($40000CC);
  REG_DM2DAD_L    : ^u16 = pointer($40000CC);
  REG_DM2DAD_H    : ^u16 = pointer($40000CE);
  REG_DM2CNT      : ^u32 = pointer($40000D0);
  REG_DM2CNT_L    : ^u16 = pointer($40000D0);
  REG_DM2CNT_H    : ^u16 = pointer($40000D2);
  REG_DM3SAD      : ^u32 = pointer($40000D4);
  REG_DM3SAD_L    : ^u16 = pointer($40000D4);
  REG_DM3SAD_H    : ^u16 = pointer($40000D6);
  REG_DM3DAD      : ^u32 = pointer($40000D8);
  REG_DM3DAD_L    : ^u16 = pointer($40000D8);
  REG_DM3DAD_H    : ^u16 = pointer($40000DA);
  REG_DM3CNT      : ^u32 = pointer($40000DC);
  REG_DM3CNT_L    : ^u16 = pointer($40000DC);
  REG_DM3CNT_H    : ^u16 = pointer($40000DE);
  REG_TM0D        : ^u16 = pointer($4000100);
  REG_TM0CNT      : ^u16 = pointer($4000102);
  REG_TM1D        : ^u16 = pointer($4000104);
  REG_TM1CNT      : ^u16 = pointer($4000106);
  REG_TM2D        : ^u16 = pointer($4000108);
  REG_TM2CNT      : ^u16 = pointer($400010A);
  REG_TM3D        : ^u16 = pointer($400010C);
  REG_TM3CNT      : ^u16 = pointer($400010E);

{$OPTIMIZATION OFF}
  REG_SCD0        : ^u16 = pointer($4000120);
  REG_SCD1        : ^u16 = pointer($4000122);
  REG_SCD2        : ^u16 = pointer($4000124);
  REG_SCD3        : ^u16 = pointer($4000126);
 
  REG_SCCNT       : ^u32 = pointer($4000128);
  REG_SCCNT_L     : ^u16 = pointer($4000128);
  REG_SIOCNT      : ^u16 = pointer($4000128);
  REG_SCCNT_H     : ^u16 = pointer($400012A);
  REG_SIODATA8    : ^u16 = pointer($400012A);
 
  REG_P1          : ^u16 = pointer($4000130);
  REG_P1CNT       : ^u16 = pointer($4000132);
  REG_R           : ^u16 = pointer($4000134);
  REG_RCNT        : ^u16 = pointer($4000134);
{$OPTIMIZATION ON}


  REG_HS_CTRL     : ^u16 = pointer($4000140);
  REG_JOYRE       : ^u32 = pointer($4000150);
  REG_JOYRE_L     : ^u16 = pointer($4000150);
  REG_JOYRE_H     : ^u16 = pointer($4000152);
  REG_JOYTR       : ^u32 = pointer($4000154);
  REG_JOYTR_L     : ^u16 = pointer($4000154);
  REG_JOYTR_H     : ^u16 = pointer($4000156);
  REG_JSTAT       : ^u32 = pointer($4000158);
  REG_JSTAT_L     : ^u16 = pointer($4000158);
  REG_JSTAT_H     : ^u16 = pointer($400015A);
  REG_IE          : ^u16 = pointer($4000200);
  REG_IF          : ^u16 = pointer($4000202);
  REG_WSCNT       : ^u16 = pointer($4000204);
  REG_IME         : ^u16 = pointer($4000208);
  REG_PAUSE       : ^u16 = pointer($4000300);
 
 
// === DMA stuff ======================================================

// DMA transfer functionality

  DMA_SHIFT       = 16;

// destination control
  _DMA_DST_INC    = ($0000 shl DMA_SHIFT);
  DMA_DST_DEC     = ($0020 shl DMA_SHIFT);
  DMA_DST_FIX     = ($0040 shl DMA_SHIFT);
  DMA_DST_RESET   = ($0060 shl DMA_SHIFT);
// source control
  _DMA_SRC_INC    = ($0000 shl DMA_SHIFT);
  DMA_SRC_DEC     = ($0080 shl DMA_SHIFT);
  DMA_SRC_FIX     = ($0100 shl DMA_SHIFT);
  DMA_SRC_RESET   = ($0180 shl DMA_SHIFT);

  DMA_REPEAT      = ($0200 shl DMA_SHIFT);
// chunks
  _DMA_16         = ($0000 shl DMA_SHIFT);
  DMA_32          = ($0400 shl DMA_SHIFT);
// timing
  _DMA_AT_NOW     = ($0000 shl DMA_SHIFT);
  DMA_AT_VBLANK   = ($1000 shl DMA_SHIFT);
  DMA_AT_HBLANK   = ($2000 shl DMA_SHIFT);
  DMA_AT_FIFO     = ($3000 shl DMA_SHIFT);		// for sound ( DMA 1 & 2)
  DMA_AT_REFRESH  = ($3000 shl DMA_SHIFT);		// for video ( DMA 3)

  DMA_IRQ         = ($4000 shl DMA_SHIFT);
  DMA_ON          = ($8000 shl DMA_SHIFT);

// I want it NOW!
  DMA_NOW         = DMA_ON or _DMA_AT_NOW;
  DMA_16NOW       = DMA_NOW or _DMA_16;
  DMA_32NOW       = DMA_NOW or DMA_32;
// copies
  DMA_CPY16       = DMA_NOW or _DMA_16;
  DMA_CPY32       = DMA_NOW or DMA_32;
// fills
  DMA_FILL16      = DMA_NOW or DMA_SRC_FIX or _DMA_16;
  DMA_FILL32      = DMA_NOW or DMA_SRC_FIX or DMA_32;

const
  BIT0  = 1;
  BIT1  = 2;
  BIT2  = 4;
  BIT3  = 8;
  BIT4  = 16;
  BIT5  = 32;
  BIT6  = 64;
  BIT7  = 128;
  BIT8  = 256;
  BIT9  = 512;
  BIT10 = 1024;
  BIT11 = 2048;
  BIT12 = 4096;
  BIT13 = 8192;
  BIT14 = 16384;
  BIT15 = 32768;


procedure Wait(count: u32);
var
  vline: u16;
begin
	vline := REG_VCOUNT^;
	dec(count);
	while (count > 0) do
	begin
		while(vline = REG_VCOUNT^) do;
		while(vline <> REG_VCOUNT^) do;
		dec(count);
	end;
end;

procedure WaitForVsync();
begin
  while (REG_VCOUNT^ < 160) do
  begin
  end;
end;


{$endif}
