// Conversion by Legolas (http://itaprogaming.free.fr) 

{ Sprites }

{$ifndef GBA_SPRITES_H}
{$define GBA_SPRITES_H}  

{$include gba_types.inc}

{ Attribute 0 }

const
  ROTATION_FLAG     = $0100;     
  SIZE_DOUBLE       = $0200;     
  MODE_NORMAL       = $0000;     
  MODE_TRANSPARENT  = $0400;     
  MODE_WINDOWED     = $0800;     
  MOSAIC            = $1000;     
  COLOR_16          = $0000;     
  COLOR_256         = $2000;     
  SQUARE            = $0000;     
  WIDE              = $4000;     
  TALL              = $8000;     


function ROTDATA(n: u32): u32;
begin
  ROTDATA := n shl 9;
end;

function PRIORITY(n: u32): u32;
begin
  PRIORITY := n shl 10;
end;

function PALETTE(n: u32): u32;
begin
  PALETTE := n shl 12;
end;


const
  HORIZONTAL_FLIP = $1000;     
  VERTICAL_FLIP   = $2000;     
  SIZE_8          = $0000;     
  SIZE_16         = $4000;     
  SIZE_32         = $8000;     
  SIZE_64         = $C000;     

{ Sprite structure definitions }
type
  tagOAMEntry = record
    attribute0: u16;
    attribute1: u16;
    attribute2: u16;
    attribute3: u16;
  end;
  OAMEntry = tagOAMEntry;
  pOAMEntry = ^tagOAMEntry;

{ Sprite rotation information (don't worry about this for now) }
  tagRotData = record
    filler1: array[0..2] of u16;
    filler2: array[0..2] of u16;
    filler3: array[0..2] of u16;
    filler4: array[0..2] of u16;
    pa: u16;
    pb: u16;
    pc: u16;
    pd: u16;
  end;
  tRotData = tagRotData;
  pRotData = ^tagRotData;

{$endif}
