// Conversion by Legolas (http://itaprogaming.free.fr) 

{$ifndef GBA_VIDEO_H}
{$define GBA_VIDEO_H}  

{ Video memory setup }


{$include gba_types.inc}
{$include gba_regs.inc}

{ Define the screen width and height values to be used }
const
  MODE_0        = $0;     { Screen mode 0 }
  MODE_1        = $1;     { Screen mode 1 }
  MODE_2        = $2;     { Screen mode 2 }
  MODE_3        = $3;     { Screen mode 3 }
  MODE_4        = $4;     { Screen mode 4 }
  MODE_5        = $5;     { Screen mode 5 }
  BACKBUFFER    = $10;    { Define the buffer which is used to set the }

  { active buffer(using double buffering) }
  H_BLANK_OAM   = $20;    { This bit, when set allows OAM }

  { (Object Attribute memory) to be updated during a }
  { horizontal blank }
  OBJ_MAP_2D    = $00;    { Sprite data is stored in a 2D array (don't use this!!) }
  OBJ_MAP_1D    = $40;    { Sprite data is stored in a 1D array }

  BG0_ENABLE    = $100;   { Enables background 0 }
  BG1_ENABLE    = $200;   { Enables background 1 }
  BG2_ENABLE    = $400;   { Enables background 2 }
  BG3_ENABLE    = $800;   { Enables background 3 }
  OBJ_ENABLE    = $1000;  { Enables sprites }

  WIN1_ENABLE   = $2000;
  WIN2_ENABLE   = $4000;
  WINOBJ_ENABLE = $8000;


{ Set the mode that you want to use, logical OR them together as below: }
{ SetMode(MODE_2 or OBJ_ENABLE or OBJ_MAP_1D); }
procedure SetMode(mode: u32);
begin
  REG_DISPCNT^ := (mode);
end;

{$endif}

